﻿
(function () {
var vue2Draggable = {}

vue2Draggable.install = function (Vue) {
  Vue.directive('draggable', {
    inserted: function (el, binding) {
      // 定位初始化
      el.style.cursor = 'default'
      // 父容器为限制元素，默认为 position = 'relative'


      // 如果拖动元素非元素本身（el），传入id
      var moveEl = binding.value && binding.value.moveElId ? document.getElementById(binding.value.moveElId) : el
      // 为拖动元素添加绝对定位
      moveEl.style.position = 'absolute'
      if (getComputedStyle(moveEl.parentNode, null).position === 'static') {
        moveEl.parentNode.style.position = 'relative'
      }
      var mouseDownFn = function (e) {
        // 拖动时才加上绝对定位，抬起时去除绝对定位


        //.shaow---------- 复制节点，并且插入容器中原来位置
        if (binding.modifiers.shaow) {
          var newNode = moveEl.cloneNode(true)
          moveEl.style.opacity = '0.5'
          moveEl.parentNode.appendChild(newNode)
        }
        //----------


        var disX, disY
        if (!binding.modifiers.dragY) disX = e.clientX - moveEl.offsetLeft
        if (!binding.modifiers.dragX) disY = e.clientY - moveEl.offsetTop
        var mouseMoveFn = function (e) {
          e.preventDefault()
          var left = e.clientX - disX
          var top = e.clientY - disY

          // 可以拖出去的元素的宽度
          // 10 为保留宽度 防止完全被拖拽出去

          // dragOutX
          var limitWidth = binding.value&&binding.value.dragOutX ? moveEl.offsetWidth - binding.value.dragOutX:0
          if (binding.value&&binding.value.dragOutY) {
            var limitHeigth = moveEl.offsetHeight - binding.value.dragOutY
            // 防止可拖拽区域被拖出容器区域
            // 拖拽元素在顶部
            var limitHeigthTop = el.offsetHeight - binding.value.dragOutY
          } else {
            var limitHeigth = 0
            var limitHeigthTop = 0
          }


          if (left < 0 - limitWidth) {
            left = 0 - limitWidth
          }
          else if (left > moveEl.parentNode.clientWidth - moveEl.offsetWidth + limitWidth) {
            left = moveEl.parentNode.clientWidth - moveEl.offsetWidth + limitWidth
          }

          if (top < 0 - limitHeigthTop) {
            top = 0 - limitHeigthTop
          }
          else if (top > moveEl.parentNode.clientHeight - moveEl.offsetHeight + limitHeigth) {
            top = moveEl.parentNode.clientHeight - moveEl.offsetHeight + limitHeigth;
          }
          moveEl.style.left = left + 'px'
          moveEl.style.top = top + 'px'

        }
        // mousemove
        document.addEventListener('mousemove', mouseMoveFn)

        var mouseUpFn = function () {
          // 拖拽结束后 进行数据操作-> 重渲染视图
          // 如果结果拖拽成功 拖拽的节点需要被移除
          // 如果结果拖拽失败 不做任何操作（会回到原位）

          // DrapDar·


          // 移除临时shaow节点
          if (newNode) {
            moveEl.style.opacity = '1'
            newNode.parentNode.removeChild(newNode)
          }
          document.removeEventListener('mousemove', mouseMoveFn)
          document.removeEventListener('mouseup', mouseUpFn)
        }
        //  mouseup
        document.addEventListener('mouseup', mouseUpFn)
      }

      // mousedown
      el.addEventListener('mousedown', mouseDownFn)

    }
  })
}




  if (typeof exports == "object") {
    module.exports = vue2Draggable;
  } else if (typeof define == "function" && define.amd) {
    define([], function () {
      return vue2Draggable
    })
  } else if (window.Vue) {
    window.vue2Draggable = vue2Draggable;
    Vue.use(vue2Draggable);
  }
})();
